美文网首页
292. Nim Game

292. Nim Game

作者: namelessEcho | 来源:发表于2017-09-22 10:42 被阅读0次

You are playing the following Nim Game with your friend: There is a heap of stones on the table, each time one of you take turns to remove 1 to 3 stones. The one who removes the last stone will be the winner. You will take the first turn to remove the stones.

Both of you are very clever and have optimal strategies for the game. Write a function to determine whether you can win the game given the number of stones in the heap.

For example, if there are 4 stones in the heap, then you will never win the game: no matter 1, 2, or 3 stones you remove, the last stone will always be removed by your friend.

这也可以看成一个博弈论问题。需要知道的问题是哪个点是决胜点,经过观察思考以后可以发现,距离N为四的整数倍的点是决胜点,能取到这个点的人肯定不会输。

例如N=7,决胜点是3,明显的第一个人可以取到它,所以他肯定能赢。对于N=8,决胜点是4,明显的第一个人不能取到他,所以怎么样都赢不了,一旦被对手取了4这个点,我怎么取都达到不了8。

class Solution {
    public boolean canWinNim(int n) {
        return n%4!=0;
    }
}

相关文章

  • Leetcode-292Nim Game

    292. Nim Game You are playing the following Nim Game with...

  • Leetcode PHP题解--D64 292. Nim Gam

    D64 292. Nim Game 题目链接 292. Nim Game 题目分析 假设你和朋友玩一个捡石头的游戏...

  • 2019-02-09

    LeetCode 292. Nim Game Description You are playing the fo...

  • 292. Nim Game

    292. Nim Game【思路】搬石头游戏,一堆石头,几个人玩,每次可以搬动1到3个石头,谁把一堆石头搬空谁就赢...

  • 292. Nim Game

    Problem You are playing the following Nim Game with your ...

  • 292. Nim Game

    1.描述 You are playing the following Nim Game with your fri...

  • 292. Nim Game

    C++ 最优解 简化bool

  • 292. Nim Game

    You are playing the following Nim Game with your friend: ...

  • 292. Nim Game

    You are playing the following Nim Game with your friend: ...

  • 292. Nim Game

    这道题的证明可以去网上搜,只要任何一步轮到自己拿时还剩4的倍数个必输,想赢同理,因此需要保证自己每次拿完之后是4的...

网友评论

      本文标题:292. Nim Game

      本文链接:https://www.haomeiwen.com/subject/vxnxextx.html